#!/usr/bin/env python
# _*_ coding: iso-8859-1 _*_

#    Conception :
#    Eole (http://eole.orion.education.fr)

#    Ce code a t dvelopp par
#    Gwenal Rmond
#    Klaas TJEBBES

#    distribu sous la licence GPL-2


from twisted.internet import protocol
from twisted.application import internet, service
from twisted.python import log
from twisted.protocols import policies
import time, ConfigParser


class Echo(protocol.Protocol, policies.TimeoutMixin):
    """This is just about the simplest possible protocol"""
    def connectionMade(self):
        self.setTimeout(30)
        self.size = 25
        log.msg('%s Opened connection'%self.transport.client[0])

    def dataReceived(self, data):
        "As soon as any data is received, write it back."
        fin_mess = data[-4:]
        if fin_mess == 'END1':
            self.tmpdata=''
            self.transport.write('ROK1')
        if fin_mess == 'END2':
            self.tmpdata=''
            self.transport.write('ROK2')
        if fin_mess == 'END3':
            self.debut = time.time()
            self.send(1)
        if fin_mess == 'ROK1':
            passed = time.time() - self.debut 
            self.size = int(self.size/passed)
            self.send(2)
            self.transport.loseConnection()

    def send(self, indice):
        self.size = self.size * 2
        message = '1'*1024*self.size
        size = '0'*(10-len(str(self.size)))+str(self.size)
        message = message[:-14]+size+'END'+str(indice)
        self.transport.write(message)

    def connectionLost(self, reason):
        log.msg('Closed connection')


def load_config_file(fich):
        parser = ConfigParser.ConfigParser()
        dico_opts={}
        try:
            parser.readfp(file(fich,'r'))
        except:
            return dico_opts
        for j in parser.sections():
            mini_dico = {}
            for i in parser.items(j):
                mini_dico[i[0]]=i[1]
                dico_opts[j] = mini_dico
        return dico_opts

fich_conf='/etc/serveur_bp/serveur_bp.conf'
dico_opts = load_config_file(fich_conf)
try:
    PORT = int(dico_opts['serveur_bp']['port'])
except:
    PORT = 50010
try:
    IP = dico_opts['serveur_bp']['ip']
except:
    IP = ''
try:
    MAX_CLI = int(dico_opts['serveur_bp']['max_clients'])
except:
    MAX_CLI = 100

log.msg('Serveur_bp started on port %s - IP %s'%(PORT,IP))
application = service.Application('ServiceBandePassante')
factory = protocol.ServerFactory()
factory.protocol = Echo
tFacto = policies.ThrottlingFactory(factory, MAX_CLI)
internet.TCPServer(PORT, tFacto, interface=IP).setServiceParent(service.IServiceCollection(application))

